Index: /NEMO/trunk/src/TOP/trcini.F90
===================================================================
--- /NEMO/trunk/src/TOP/trcini.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/trcini.F90	(revision 10425)
@@ -72,5 +72,5 @@
       CALL trc_ice_ini   ! Tracers in sea ice
       !
-      IF(lwp) CALL ctl_opn( numstr, 'tracer.stat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp , narea )
+      IF(lwm) CALL ctl_opn( numstr, 'tracer.stat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp , narea )
       !
       CALL trc_ini_state  !  passive tracers initialisation : from a restart or from clim
@@ -119,9 +119,9 @@
       END DO
       !                          ! total volume of the ocean 
-      areatot = glob_sum( cvol(:,:,:) )
+      areatot = glob_sum( 'trcini', cvol(:,:,:) )
       !
       trai(:) = 0._wp            ! initial content of all tracers
       DO jn = 1, jptra
-         trai(jn) = trai(jn) + glob_sum( trn(:,:,:,jn) * cvol(:,:,:)   )
+         trai(jn) = trai(jn) + glob_sum( 'trcini', trn(:,:,:,jn) * cvol(:,:,:)   )
       END DO
 
@@ -292,5 +292,5 @@
 #endif
       !
-      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      CALL mpp_sum( 'trcini', ierr )
       IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'top_alloc : unable to allocate standard ocean arrays' )
       !
Index: /NEMO/trunk/src/TOP/trcnam.F90
===================================================================
--- /NEMO/trunk/src/TOP/trcnam.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/trcnam.F90	(revision 10425)
@@ -23,4 +23,7 @@
    USE trdtrc_oce  !
    USE iom         ! I/O manager
+#if defined key_mpp_mpi
+   USE lib_mpp, ONLY: ncom_dttrc
+#endif
 
    IMPLICIT NONE
@@ -76,5 +79,5 @@
       ENDIF
       !
-      rdttrc = rdt * FLOAT( nn_dttrc )          ! passive tracer time-step
+      rdttrc = rdt * FLOAT( nn_dttrc )          ! passive tracer time-step      
       ! 
       IF(lwp) THEN                              ! control print
@@ -128,5 +131,9 @@
       ENDIF
       !
-    END SUBROUTINE trc_nam_run
+#if defined key_mpp_mpi
+      ncom_dttrc = nn_dttrc    ! make nn_fsbc available for lib_mpp
+#endif
+      !
+   END SUBROUTINE trc_nam_run
 
 
Index: /NEMO/trunk/src/TOP/trcrst.F90
===================================================================
--- /NEMO/trunk/src/TOP/trcrst.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/trcrst.F90	(revision 10425)
@@ -23,4 +23,5 @@
    USE iom
    USE daymod
+   USE lib_mpp
    
    IMPLICIT NONE
@@ -87,5 +88,5 @@
          IF(lwp) WRITE(numout,*) &
              '             open trc restart.output NetCDF file: ',TRIM(clpath)//clname
-         CALL iom_open( TRIM(clpath)//TRIM(clname), numrtw, ldwrt = .TRUE., kiolib = jprstlib )
+         CALL iom_open( TRIM(clpath)//TRIM(clname), numrtw, ldwrt = .TRUE. )
          lrst_trc = .TRUE.
       ENDIF
@@ -116,4 +117,6 @@
       END DO
       !
+      CALL iom_delay_rst( 'READ', 'TOP', numrtr )   ! read only TOP delayed global communication variables
+      
    END SUBROUTINE trc_rst_read
 
@@ -127,5 +130,4 @@
       !!
       INTEGER  :: jn
-      REAL(wp) :: zarak0
       !!----------------------------------------------------------------------
       !
@@ -141,4 +143,6 @@
       END DO
       !
+      CALL iom_delay_rst( 'WRITE', 'TOP', numrtw )   ! save only TOP delayed global communication variables
+    
       IF( kt == nitrst ) THEN
           CALL trc_rst_stat            ! statistics
@@ -184,5 +188,4 @@
       CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
       !
-      INTEGER  ::  jlibalt = jprstlib
       LOGICAL  ::  llok
       REAL(wp) ::  zrdttrc1, zkt, zndastp, zdayfrac, ksecs, ktime
@@ -199,5 +202,5 @@
 
          IF( ln_rsttr ) THEN
-            CALL iom_open( TRIM(cn_trcrst_indir)//'/'//cn_trcrst_in, numrtr, kiolib = jlibalt )
+            CALL iom_open( TRIM(cn_trcrst_indir)//'/'//cn_trcrst_in, numrtr )
             CALL iom_get ( numrtr, 'kt', zkt )   ! last time-step of previous run
 
@@ -316,10 +319,10 @@
       !
       DO jn = 1, jptra
-         ztraf = glob_sum( trn(:,:,:,jn) * zvol(:,:,:) )
+         ztraf = glob_sum( 'trcrst', trn(:,:,:,jn) * zvol(:,:,:) )
          zmin  = MINVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
          zmax  = MAXVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
          IF( lk_mpp ) THEN
-            CALL mpp_min( zmin )      ! min over the global domain
-            CALL mpp_max( zmax )      ! max over the global domain
+            CALL mpp_min( 'trcrst', zmin )      ! min over the global domain
+            CALL mpp_max( 'trcrst', zmax )      ! max over the global domain
          END IF
          zmean  = ztraf / areatot
Index: /NEMO/trunk/src/TOP/trcstp.F90
===================================================================
--- /NEMO/trunk/src/TOP/trcstp.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/trcstp.F90	(revision 10425)
@@ -20,4 +20,5 @@
    USE trdtrc_oce
    USE trdmxl_trc
+   USE sms_pisces,  ONLY : ln_check_mass
    !
    USE prtctl_trc     ! Print control for debbuging
@@ -73,5 +74,8 @@
             cvol(:,:,jk) = e1e2t(:,:) * e3t_n(:,:,jk) * tmask(:,:,jk)
          END DO
-         areatot         = glob_sum( cvol(:,:,:) )
+         IF ( ln_ctl .OR. kt == nitrst .OR. ( ln_check_mass .AND. kt == nitend )              &
+            & .OR. iom_use( "pno3tot" ) .OR. iom_use( "ppo4tot" ) .OR. iom_use( "psiltot" )   &
+            & .OR. iom_use( "palktot" ) .OR. iom_use( "pfertot" ) )                           &
+            &     areatot = glob_sum( 'trcstp', cvol(:,:,:) )
       ENDIF
       !
@@ -105,9 +109,11 @@
       ENDIF
       !
-      ztrai = 0._wp                                                   !  content of all tracers
-      DO jn = 1, jptra
-         ztrai = ztrai + glob_sum( trn(:,:,:,jn) * cvol(:,:,:)   )
-      END DO
-      IF( lwp ) WRITE(numstr,9300) kt,  ztrai / areatot
+      IF (ln_ctl ) THEN
+         ztrai = 0._wp                                                   !  content of all tracers
+         DO jn = 1, jptra
+            ztrai = ztrai + glob_sum( 'trcstp', trn(:,:,:,jn) * cvol(:,:,:)   )
+         END DO
+         IF( lwm ) WRITE(numstr,9300) kt,  ztrai / areatot
+      ENDIF
 9300  FORMAT(i10,D23.16)
       !
Index: /NEMO/trunk/src/TOP/trcsub.F90
===================================================================
--- /NEMO/trunk/src/TOP/trcsub.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/trcsub.F90	(revision 10425)
@@ -308,5 +308,5 @@
 
       ierr =  trc_sub_alloc    ()
-      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      CALL mpp_sum( 'trcsub', ierr )
       IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'top_sub_alloc : unable to allocate standard ocean arrays' )
 
@@ -510,5 +510,5 @@
          IF( ln_bdy ) THEN
             ssha(:,:) = ssha(:,:) * bdytmask(:,:)
-            CALL lbc_lnk( ssha, 'T', 1. ) 
+            CALL lbc_lnk( 'trcsub', ssha, 'T', 1. ) 
          ENDIF
       ENDIF
@@ -535,5 +535,5 @@
       !!                    *** ROUTINE trc_sub_alloc ***
       !!-------------------------------------------------------------------
-      USE lib_mpp, ONLY: ctl_warn
+      USE lib_mpp, ONLY: ctl_stop
       INTEGER ::  ierr(3)
       !!-------------------------------------------------------------------
@@ -577,5 +577,5 @@
       trc_sub_alloc = MAXVAL( ierr )
       !
-      IF( trc_sub_alloc /= 0 )   CALL ctl_warn('trc_sub_alloc: failed to allocate arrays')
+      IF( trc_sub_alloc /= 0 )   CALL ctl_stop( 'STOP', 'trc_sub_alloc: failed to allocate arrays' )
       !
    END FUNCTION trc_sub_alloc
